package server;
import java.net.*;
import java.io.*;
import java.util.*;
import java.security.MessageDigest;
import java.util.Arrays;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

public class cThread extends Thread
{
	public String IP;
	public byte[] encrypt(String message) throws Exception {
        MessageDigest md = MessageDigest.getInstance("md5");
        byte[] digestOfPassword = md.digest("ABCDEABCDE"
                        .getBytes("utf-8"));
        byte[] keyBytes = Arrays.copyOf(digestOfPassword, 24);
        for (int j = 0, k = 16; j < 8;) {
                keyBytes[k++] = keyBytes[j++];
        }

        SecretKey key = new SecretKeySpec(keyBytes, "DESede");
        IvParameterSpec iv = new IvParameterSpec(new byte[8]);
        Cipher cipher = Cipher.getInstance("DESede/CBC/PKCS5Padding");
        cipher.init(Cipher.ENCRYPT_MODE, key, iv);

        byte[] plainTextBytes = message.getBytes("utf-8");
        byte[] cipherText = cipher.doFinal(plainTextBytes);
        // String encodedCipherText = new sun.misc.BASE64Encoder()
        // .encode(cipherText);
        return cipherText;
    }
	String userName;      
	Boolean connected;
	Vector<String> helpList = new Vector<String>(); 
	Socket socket;
	PrintWriter out; 
	BufferedReader in;
	Socket clientSocket;
	
	cThread(Socket s)
	{
		super("cThread");
		connected = false;
		userName = "";
		clientSocket = s;
		try 
		{
			out = new PrintWriter(clientSocket.getOutputStream(), true);
			in = new BufferedReader(new InputStreamReader(clientSocket.getInputStream()));
		}
		catch (Exception e)
		{
			e.printStackTrace();
			System.out.println(e);
		}
	}
	
	public boolean equals(cThread c)
	{
		return (c.userName.equals(this.userName));
	}
	
	synchronized void send(String msg)
	{
			out.println(msg);	
	}
	void listen()
	{
		try 
		{
			while (true)
			{	   			
	       	    String msg = in.readLine();
	        	if (msg.startsWith("Login"))
	        	{
					login(msg);
	        	}
	        	else if(msg.equals("IsHD"))
	        	{
	        		boolean isHD = false;
	        		for (int i = 0; i < server.clients.size() ; i ++)
    				{
    					cThread t = (cThread)server.clients.get(i);
    					if (t.connected && !t.userName.startsWith("Anon")) 
    					{
    						isHD = true;
    					}
    				}
	        		send("NoOne "+ isHD);
	        	}
	        	else if(msg.startsWith("Add "))
	        	{
	        		String uName = msg.substring(4, msg.length());
	        		try
	        		{
	    			if(uName.startsWith("Anon"))
	    			{
	    				cThread t=null;
	    				String hd = "";
	    				int j=999999;
	    				for (int i = 0; i < server.clients.size() ; i ++)
	    				{
	    					t = (cThread)server.clients.get(i);
	    					if (t.connected && !t.userName.startsWith("Anon")) 
	    					{
	    						j=Math.min(t.helpList.size(), j);
	    					}
	    				}
	    				for (int i = 0; i < server.clients.size() ; i ++)
	    				{
	    					t = (cThread)server.clients.get(i);
	    					if (t.connected && !t.userName.startsWith("Anon")) 
	    					{
	    						if(j==t.helpList.size())
	    							break;
	    					}
	    				}
	    				t.helpList.add(uName);
	    				for (int i = 0; i < server.clients.size() ; i ++)
		        		{
		        			cThread tt = (cThread)server.clients.get(i);
		        			if (tt.userName.equals(uName) && tt.connected)
		        			{
		        				hd = t.userName;
		        				break;
		        			}
		        			tt.sendList();
		        		}
	    				sendList();
	    				for(int i=0; i<server.clients.size(); i++)
	        			{
		        			cThread e = (cThread)server.clients.get(i);
		        			if(e.userName.equals(uName))
		        			{
		        				e.send("PrivateRecieve "+ "Hi "+uName+". You are now chatting with "+ hd);
		        			}
	        		
	        			}
	    			}
	        		}
	        		catch(Exception e)
	        		{
	        			e.printStackTrace();
	        		}
	   
	        	}
	        	else if (msg.startsWith("Logout "))
	        	{
	        		String user=msg.substring(7,msg.length());
	        		if (connected)
	        		{
	        			for(int i=0; i<server.IPlist.size(); i++)
	        			{
	        				if(server.IPlist.get(i).getI().substring(0, 10).equals(IP.substring(0, 10)) && server.IPlist.get(i).getnumCon()>0)
	        				{
	        					server.IPlist.get(i).decnum();
	        					break;
	        				}
	        				else if(server.IPlist.get(i).getI().substring(0, 10).equals(IP.substring(0, 10)) && server.IPlist.get(i).getnumCon()==0)
	        				{
	        					server.IPlist.remove(server.IPlist.get(i));
	        					break;
	        				}
	        			}
	        			try{
	        			if(!user.startsWith("Anon"))
		        		{
	        				for (int i = 0; i < server.clients.size() ; i ++)
		    				{
		    					cThread t = (cThread)server.clients.get(i);
		    					if (!t.userName.startsWith("Anon") && t.userName.equals(user)) 
		    					{
		    						for(int u=0; u<t.helpList.size(); u++)
		    						{
		    							for(int y=0; y<server.clients.size(); y++)
			    						{
		    								String target = "";
		    								cThread p = (cThread)server.clients.get(y);
			    							if(p.userName.equals(helpList.get(u)))
			    							{
			    								for (int r = 0; r < server.clients.size() ; r ++)
			    			    				{
			    									cThread h = (cThread)server.clients.get(r);
			    									if(!h.userName.startsWith("Anon") && !h.userName.equals(user))
			    									{
			    										target=h.userName;
			    										break;
			    									}
			    			    				}
			    								if(target.equals(""))
			    								{
			    									p.send("Done");
			    								}
			    								else
			    								{
			    									p.send("Lost "+ user + ","+ target);
			    								}
			    							}
			    						}
		    						}
		    					}
		    				}
		        		}
	        			for (int i = 0; i < server.clients.size() ; i ++)
	    				{
	    					cThread t = (cThread)server.clients.get(i);
	    					if (!t.userName.startsWith("Anon")) 
	    					{
	    						for(int u=0; u<t.helpList.size(); u++)
	    						{
	    							if(t.helpList.get(u).equals(user));
	    								t.helpList.remove(user);
	    						}
	    					}
	    				}

	        			server.clients.remove(this);
	        			sendList();
	        			connected = false;
	        			out.println("OK");
	        			out.close();
	        			in.close();
	        			return;
	        			}
	        			catch(Exception e)
	        			{
	        				e.printStackTrace();
	        				sendList();
	        			}
	        		}
	        		else
	        		{
	        			send("Not Logged in !!");
	        		}
	        	}
	        	else if(msg.startsWith("Change "))
	        	{
	        		StringTokenizer st = new StringTokenizer(msg.substring(7,msg.length()),", "); 
	        		String user = st.nextToken();	        		
	        		String target = st.nextToken();
	        		
	        		for(int i=0; i<server.clients.size(); i++)
        			{
	        			cThread t = (cThread)server.clients.get(i);
	        			if(t.userName.equals(user) && t.helpList.contains(target))
	        			{
	        				t.helpList.remove(target);
	        				t.helpList.add(0, target);
	        			}
        			}
	        	}
	        	else if(msg.startsWith("Valid "))
	        	{
	        		StringTokenizer st = new StringTokenizer(msg.substring(6,msg.length()),","); 
	        		String un  = st.nextToken();
	        		String pass =st.nextToken();
	        		String together = un + " " + pass;
	        		byte[] codedtext1 = encrypt(together);
	        		boolean isValid = false;
	        		 File file = new File("hdusers");
	                 byte[] b = new byte[(int) file.length()];
	                 FileInputStream fileInputStream = new FileInputStream("hdusers");
	                 fileInputStream.read(b);
	                 byte[] b2 = "@!#".getBytes();
	                 ByteTokenizer tokenizer = new ByteTokenizer(b, b2);
	                 byte[] token;
	             	while(tokenizer.hasMoreTokens()) {
	             		token = (byte[]) tokenizer.nexToken();
	             		if(Arrays.equals(codedtext1, token))
	             		{
	             			isValid=true;
	             			break;
	             		}
	             	}
	                fileInputStream.close();
	        		send("Check "+ isValid);
	        	}
	        	else if(msg.startsWith("Transfer "))
	        	{
	        		StringTokenizer st = new StringTokenizer(msg.substring(9,msg.length()),", "); 
	        		String user = st.nextToken();
	        		String anonToTransfer = st.nextToken();
	        		String otherH = st.nextToken();
	        		boolean good=false;
	        		boolean isthere = false;
	        		for(int i=0; i<server.clients.size(); i++)
        			{
	        			cThread t = (cThread)server.clients.get(i);
	        			if(otherH.equals(t.userName))
	        				isthere=true;
        			}
	        		if(!isthere)
	        		{
	        			send("Error");
	        			break;
	        		}
	        		if(!otherH.startsWith("Anon") && !user.equals(otherH))
	        		{
	        			good=true;
	        		}
	        		for(int i=0; i<server.clients.size() && good; i++)
        			{
	        			cThread t = (cThread)server.clients.get(i);
	        			if(!t.userName.startsWith("Anon"))
	        			{
	        				if(!t.userName.equals(otherH))
	        				{
	        					for(int u=0; u<t.helpList.size(); u++)
	        					{
	        						if(t.helpList.get(u).equals(anonToTransfer))
	        						{
	        							t.helpList.remove(anonToTransfer);
	        						}
	        					}
	        				}
	        				else if(t.userName.equals(otherH))
	        				{
	        					t.helpList.add(anonToTransfer);
	        		
	        				}
	        			}
	        			sendList();
        			}
	        		sendList();
	        		for(int i=0; i<server.clients.size(); i++)
        			{
	        			cThread t = (cThread)server.clients.get(i);
	        			if(t.userName.equals(anonToTransfer))
	        			{
	        				t.send("PrivateRecieve "+ otherH+": " + "Hi "+anonToTransfer+".You have been transferred to another help desk assistant: "+ otherH);
	        			}
        		
        			}
	        	}
	        	else if (msg.startsWith("Post "))
	        	{
	        		StringTokenizer st = new StringTokenizer(msg.substring(5,msg.length()),",");   	
	        		
	        		String message = st.nextToken();	    
	        		//String message= msg.substring(6, msg.length());
	        		String from = st.nextToken();
	        		String to=from;
					boolean success = false;
					boolean done = true;
					try
					{
	        		if(from.startsWith("Anon"))
	        		{
	        			for(int i=0; i<server.clients.size() && done; i++)
	        			{
	        				cThread t = (cThread)server.clients.get(i);
	        				if(!t.userName.startsWith("Anon"))
	        				{
	        					for(int u=0; (u<t.helpList.size()) &&(t.helpList.size()>0); u++)
	        					{
	        						String g = t.helpList.get(u);
	        						if(g.equals(from))
	        						{
	        							to=t.userName;
	        							done=false;
	        							break;
	        						}	
	        					}
	        					
	        				}
	        			}
	        			
	        		}
	        		else if(!from.startsWith("Anon"))
	        		{
	        			for(int i =0; i<server.clients.size(); i++)
	        			{
	        				cThread t = (cThread)server.clients.get(i);
	        				if(t.userName.equals(from))
	        				{
	        					to=t.helpList.get(0);
	        				}
	        			}
	        		}
	        		for (int i = 0; i < server.clients.size() ; i ++)
	        		{
	        			cThread t = (cThread)server.clients.get(i);
	        			if (t.userName.equals(to))
	        			{
	        				t.send("PrivateRecieve "+ userName+": " + message);
	        				success = true;
	        				break;
	        			}
	        		}
	        			 
	        		if (!success)
	        		{
	        			send("Error: userName");
	        		}
					}
					catch(Exception e)
					{
						e.printStackTrace();
						for(int i =0; i<server.clients.size(); i++)
	        			{
	        				cThread t = (cThread)server.clients.get(i);
	        				if(t.userName.equals(from))
	        				{
	        					t.send("PrivateRecieve "+ from+": " + "No one to talk to!");
	        				}
	        			}
					}
	        	}
	        	else if (msg.startsWith("PrivatePost "))
	        	{
	        		StringTokenizer st = new StringTokenizer(msg.substring(12,msg.length()),",");   	
	        		
	        		String message = st.nextToken();	        		
	        		String to = st.nextToken();
	        		
					boolean success = false;
	        		
	        	
	        		for (int i = 0; i < server.clients.size() ; i ++)
	        		{
	        			cThread t = (cThread)server.clients.get(i);
	        			if (t.userName.equals(to))
	        			{
	        				t.send("PrivateRecieve "+ userName+": " + message);
	        				success = true;
	        				break;
	        			}
	        		}
	        			 
	        		if (!success)
	        		{
	        			send("Error: userName");
	        		}       		
	        	}
	        	else
	        	{
	        		send(msg);
	        	}
	   		}
		}
		catch (Exception e)
		{
			System.out.println();
				    if (connected)
	        		{
				    	try{
		        			for (int i = 0; i < server.clients.size() ; i ++)
		    				{
		    					cThread t = (cThread)server.clients.get(i);
		    					if (!t.userName.startsWith("Anon")) 
		    					{
		    						for(int u=0; u<t.helpList.size(); u++)
		    						{
		    							if(t.helpList.get(u).equals(this.userName));
		    								t.helpList.remove(this.userName);
		    						}
		    						sendList();
		    					}
		    				}
		        			connected = false;
		        			server.clients.remove(this);
							sendList();
		        			out.println("OK");
		        			out.close();
		        			in.close();
		        			clientSocket.close();
		        			return;
		        			}
		        			catch(Exception t)
		        			{
		        				t.printStackTrace(); 
		        				sendList();
		        			}
	        		}
		}
	}

	private boolean startsWith(String string) {
		// TODO Auto-generated method stub
		return false;
	}

	public void run() 
	{
		try{
			listen();
		}
		catch(NullPointerException e)
		{
			System.out.println("");
		}
	}
	
	boolean login(String msg)
	{
		
	    if (connected)
	    {
	    	out.println("Already Connected!");
	    	return true;
	    }
		boolean exists = false;

	    for (int i = 0;i<server.clients.size();i++)
	    {
	    	if (server.clients.get(i) != null)
	        {
				//System.out.println(msg.substring(7, msg.length()));
				cThread temp = (cThread)server.clients.get(i);
	        	if ((temp.userName).equals(msg.substring(7, msg.length())))
	        	{
					exists = true;
	        		break;
	        	}
	        }
		}
		if (exists)
		{
			out.println("NewuserName");
		}
		else
		{
			connected = true;		
			userName = msg.substring(7,msg.length());
	        sendList();
		}
	    return true;
	}
	void sendList()
	{
		String list = "";

		String[] allLists = new String[server.clients.size()];
		try{
		for (int i = 0;i<server.clients.size();i++)
	    {
			cThread temp = (cThread)server.clients.get(i);
			if (connected && (!temp.userName.startsWith("Anon")))
    		{
				list =temp.userName + "," + list ;
    		}
	    }
		for(int i=0; i<server.clients.size(); i++)
		{
			allLists[i]=list;
		}


	    for (int i = 0;i<server.clients.size();i++)
	    {
	    	cThread temp = (cThread)server.clients.get(i); 
	    	
	    	if (!temp.userName.startsWith("Anon") && temp.connected)
	        {
	        		for(int u=0; u<temp.helpList.size(); u++)
	        		{
	        			 allLists[i]=temp.helpList.get(u) + "," + allLists[i];
	        		}
	        }
		}
	    
		}
		catch(Exception y)
    	{
			y.printStackTrace();
    		System.out.println();
    	}
	    for(int i=0; i<server.clients.size(); i++)
		{
	    	try{
	    		if(allLists[i].length()>0)
	    		allLists[i] = "List " +allLists[i].substring(0,allLists[i].length() -1) +";";
	    	}
	    	catch(Exception y)
	    	{
	    		System.out.println(y);
	    		y.printStackTrace();
	    	}
		}		
	    for (int i = 0; i < server.clients.size() ; i ++)
	    {
	    	cThread t = (cThread)server.clients.get(i);
	    	if (t.connected)
	    	{
	    		t.send(allLists[i]);
	    	}
	    }
	}
	static String replace(String str, String pattern, String replace) 
	{
  	  	int s = 0;
  	  	int e = 0;
  	  	StringBuffer result = new StringBuffer();
    	while ((e = str.indexOf(pattern, s)) >= 0) 
    	{
    		result.append(str.substring(s, e));
       	    result.append(replace);
       	    s = e+pattern.length();
    	}
    	result.append(str.substring(s));
    	return result.toString();
    }
}